#ifndef SCANAP_H
#define SCANAP_H

#include <WiFi.h>
#define DEBUG_SCANAP

#ifdef DEBUG_SCANAP
#define DEBUG_SCANAP_LN(...) ets_printf(__VA_ARGS__)
#else
#define DEBUG_SCANAP_LN(...)
#endif

class ScanAp {

    
  public:
    ScanAp(std::function < void(int)> callback){
      _callback = callback;
    }
    bool drive() {
      _count = WiFi.scanComplete();

      if (_count == WIFI_SCAN_FAILED) {
        DEBUG_SCANAP_LN("");
        DEBUG_SCANAP_LN("Last Failed !!");
        DEBUG_SCANAP_LN("scan");
        WiFi.scanNetworks(true, false);
        return false;

      } else if (_count == WIFI_SCAN_RUNNING) {

        DEBUG_SCANAP_LN(".");
        return false;
      } else if (  _count == 0) {

        DEBUG_SCANAP_LN("No Networks found");
        WiFi.scanNetworks(true, false);
        DEBUG_SCANAP_LN("scan");
        _callback(_count);
        return false;
      } else if (_count > 0)
      {
        
        DEBUG_SCANAP_LN("done ");
        DEBUG_SCANAP_LN(String(_count).c_str());
        DEBUG_SCANAP_LN(" found!");
        DEBUG_SCANAP_LN("scan ");
        _callback(_count);
        WiFi.scanNetworks(true, false);
        return true;
      } else {

        DEBUG_SCANAP_LN("First start!");
        WiFi.scanNetworks(true, false);
        return false;
      }
    }

    void init() {

    }


    String toString () {
      String s ;
      s.reserve(300);
      for (int i = 0; i < _count; ++i)
      {
        s.concat("(");
        s.concat(String(WiFi.RSSI(i)).c_str());
        s.concat(") ");
        s.concat(WiFi.SSID(i));
        s.concat("\n");
      }
      return s;
    }

   

  private:

   int  _count = 0;
   std::function < void(int)> _callback;

};
#endif // SCANAP_H
